.\"     Title: saxonb-xquery
.\"    Author: 
.\" Generator: DocBook XSL Stylesheets v1.73.2 <http://docbook.sf.net/>
.\"      Date: February 2008
.\"    Manual: 
.\"    Source: 
.\"
.TH "SAXONB\-XQUERY" "1" "February 2008" "" ""
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.SH "NAME"
saxonb-xquery - command line XQuery processor
.SH "SYNOPSIS"
.HP 14
\fBsaxonb\-xquery\fR [\fIOPTION\fR...] \fI\fIQUERYFILE\fR\fR [\fINAME\fR=\fIVALUE\fR...]
.SH "DESCRIPTION"
.PP
This manual page documents briefly the
\fBsaxonb\-xquery\fR
command\. This page was written for the
Debian(TM)
distribution because the original program does not have a manual page\. Still, it has HTML documentation which is shipped in the
libsaxonb\-java\-doc
package\.
.PP
\fBsaxonb\-xquery\fR
is a command line wrapper around the Saxon\-B XSLT and XQuery processor\. Using
\fBsaxonb\-xquery\fR
you can evaluate
\fIXQuery\fR
queries directly from the command line\. Internally,
\fBsaxonb\-xquery\fR
is a wrapper around the Java class
\fBnet\.sf\.saxon\.Query\fR
implemented by Saxon\-B\.
.PP
\fBsaxonb\-xquery\fR
should be invoked passing a (required) filename containing the XQuery query to be evaluated; the special filename "\-" can be given to require reading the query from standard input\.
.PP
Before the query filename a list of options can be given, see below\.
.SS "Parameters"
.PP
At the end of the command line, a list of
\fIparameters\fR
can be given\. Parameters are passed using the syntax
\fINAME\fR=\fIVALUE\fR, to specify parameters\' names and values\.
.PP
A parameter name prefixed with "+" (plus sign) will be interpreted as a
\fIfilesystem path parameter\fR
If the path points to a single file, that file will be parsed as XML and its document node will be passed as the parameter value\. If the path points to a directory, all directly contained files will be parsed as XML files, and the sequence of their document nodes will be passed as the parameter value\.
.PP
A parameter name prefixed with "!" (exclamation mark) will be interpted as a output/serialization parameter\. See the specifications of XQuery and XSLT 2\.0 for more information on output/serialization parameters\.
.PP
To pass parameters belonging to the non\-null namespace, the syntax {\fIuri\fR}\fIlocalname\fR=\fIvalue\fR
is provided\.
.PP
Parameters will be visible as external variables during query evaluation, provided they have been declared in the query prolog\. See the XQuery specification for more information on variables and their declarations\.
.SH "OPTIONS"
.PP
A summary of supported options is included below\. Options can be passed in any order\.
.PP
We first report the options which are shared by
\fBsaxonb\-xquery\fR
and
\fBsaxonb\-xslt\fR, then those specific to
\fBsaxonb\-xquery\fR
(or which have a different semantics)\.
.PP
Some options are flagged as "Saxon\-SA only", such options work only if Saxon\-SA is installed\. Note that Saxon\-SA is a commercial product, as such it is not available in Debian\.
.SS "Common options"
.PP
\fB\-cr\fR:\fIclassname\fR
.RS 4
Specify a class to be used for processing collection URIs passed to the
\fBcollection()\fR
function\. The class must implement
net\.sf\.saxon\.CollectionURIResolver\.
.RE
.PP
\fB\-dtd\fR: {[on] | [off]}
.RS 4
Enable or disable DTD validation\. Default: off\.
.RE
.PP
\fB\-expand\fR: {[on] | [off]}
.RS 4
When validation is enabled, expand default values in validated documents\. This option enables or disables such an expansion\. Default: on\.
.RE
.PP
\fB\-explain\fR [:\fIfilename\fR]
.RS 4
Display an execution plan; the output is in XML format\. If filename is not given it will be displayed on standard output\.
.RE
.PP
\fB\-ext\fR: {[on] | [off]}
.RS 4
Enable or disable the ability to invoke external Java functions from query files and stylesheets\. Beware that enabling them is a potential security risk when processing untrusted files\. Default: off\.
.RE
.PP
\fB\-l\fR: {[on] | [off]}
.RS 4
Keep (when on) or throw away (when off) line numbers in tress corresponding to source documents\. When kept, line numbers can be accessed using the function
\fBsaxon:line\-number()\fR\. Default: off\.
.RE
.PP
\fB\-outval\fR: {[recover] | [fatal]}
.RS 4
When validation is required, set whether validation errors are fatal (when "fatal" is passed) or if they only trigger warnings (when "recover" is)\. Default: fatal\.
.RE
.PP
\fB\-p\fR: {[on] | [off]}
.RS 4
Enable or disable usage of the
PTreeURIResolver\. Saxon\-SA only\.
.RE
.PP
\fB\-r\fR:\fIclassname\fR
.RS 4
Specify a class to be used for resolving all URIs\.
.RE
.PP
\fB\-repeat\fR:\fIN\fR
.RS 4
Repeat the transformation N times\. For benchmarking purposes\.
.RE
.PP
\fB\-sa\fR
.RS 4
Perform Schema\-aware processing\. Saxon\-SA only\.
.RE
.PP
\fB\-strip\fR: {[all] | [none] | [ignorable]}
.RS 4
Specify whitespace stripping policy for source documents: strip all of them ("all"), strip none of them ("none"), strip ignorable whitespace only ("ignorable")\. Default: none\.
.RE
.PP
\fB\-t\fR
.RS 4
Display version, timing, and other debugging information on standard error\.
.RE
.PP
\fB\-tree\fR: {[tiny] | [linked]}
.RS 4
Select the implementation of the internal tree model: tiny tree model ("tiny") or linked tree model ("linked")\. See the Saxon documentation for more information on the internal tree model\. Default: tiny\.
.RE
.PP
\fB\-T\fR [:\fIclassname\fR]
.RS 4
Trace various aspect of the processing; an optional class name can be given to specify a user\-chosen tracer\. The class must implement
net\.sf\.saxon\.trace\.TraceListener\. The default is a system supplied tracer\. This option implies
\fB\-l\fR\.
.RE
.PP
\fB\-TJ\fR
.RS 4
Enable tracing of external Java method invocation\. See
\fB\-ext\fR\.
.RE
.PP
\fB\-u\fR
.RS 4
Force interpretation of source document names as URI\. By default they are considered to be file names, unless they start with "file:" or "http:"\.
.RE
.PP
\fB\-val\fR: {[strict] | [lax]}
.RS 4
When validation is enabled, choose among "strict" or "lax" validation\. Saxon\-SA only\.
.RE
.PP
\fB\-x\fR:\fIclassname\fR
.RS 4
Specify a class to be used as SAX parser for input documents\. The class must implement either
org\.xml\.sax\.Parser
or
org\.xml\.sax\.XMLReader\.
.RE
.PP
\fB\-xi\fR
.RS 4
Apply XInclude processing to all input documents\.
.RE
.PP
\fB\-xmlversion\fR: {[1\.0] | [1\.1]}
.RS 4
Choose the XML version for processing input documents\. "1\.1" must be specified to process XML 1\.1 and Namespaces 1\.1 constructs\. Default: 1\.0\.
.RE
.PP
\fB\-?\fR
.RS 4
Display a help message and exit\.
.RE
.SS "Options specific to saxonb\-xquery"
.PP
\fB\-mr:\fR\fB\fIclassname\fR\fR
.RS 4
Use the specified class as a
ModuleURIResolver
to resolve query module URIs\. The class must implement
net\.sf\.saxon\.query\.ModuleURIResolver\.
.RE
.PP
\fB\-o\fR:\fIfilename\fR
.RS 4
Send the query output to the specified filename\. If not specified the output will be sent to standard output\. See also
\fB\-wrap\fR\.
.RE
.PP
\fB\-pipe\fR: {[push] | [pull]}
.RS 4
Internally, execute query in push or pull mode\. Mainly for testing purposes\. Push mode is usually faster when intermediate tree are constructed in memory\. Default: push\.
.RE
.PP
\fB\-projection\fR: {[on] | [off]}
.RS 4
Enable or disable document projection, i\.e\. the ability to throw away tree parts which will not be accessed by a query\. Saxon\-SA only\.
.RE
.PP
\fB\-s\fR: {[\fIfile\fR] | [\fIURI\fR]}
.RS 4
Read document input from the specified filename ("\-" can be given to read from standard input)\. The read document will be available to the query as the context node\.
\fB\-u\fR
affects how filename is interpreted\.
.RE
.PP
\fB\-wrap\fR: {[on] | [off]}
.RS 4
Enable or disable wrapping of query result in a XML structure which makes explicit the kind of each output node or atomic value\. For example free\-standing attributes will be wrapped in an explicit XML element stating that they are attributes\. When this is off, the query output will be wrapped only using a document node; in such a setting is possible that output parts, such as free\-standing attributes, can\'t be serialized\. Default: off\.
.RE
.SH "SEE ALSO"
.PP
saxonb\-xslt (1), XQuery 1\.0: An XML Query Language (W3C Recommendation)\.
.PP
This program is fully documented by the HTML documentation of Saxon, available in the
libsaxon\-java\-doc
Debian package\.
.SH "AUTHOR"
.PP
This manual page was written by
Stefano
Zacchiroli
<zack@debian\.org>
for the
Debian(TM)
system (but may be used by others)\. Permission is granted to copy, distribute and/or modify this document under the terms of the
GNU
General Public License, Version 3 or any later version published by the Free Software Foundation\.
.PP
On Debian systems, the complete text of the GNU General Public License can be found in /usr/share/common\-licenses/GPL\.
.SH "COPYRIGHT"
Copyright \(co 2008 Stefano Zacchiroli
.br
